#include <ruby.h>
#include <intern.h>
#include <Epsilon.h>

VALUE cEpsilon;

static VALUE rb_epsilon_new(klass, fname)
	VALUE klass, fname;
{
	Epsilon *image = NULL;
	VALUE retval;

	Check_Type(fname, T_STRING);
	if(StringValueCStr(fname)[0] != '/') {
		fname = rb_file_s_expand_path(1, &fname);
	}

	image = epsilon_new(StringValueCStr(fname));
	retval = Data_Wrap_Struct(klass, NULL, epsilon_free, image); 
	rb_obj_call_init(retval, 0, NULL);
	return retval;
}

VALUE rb_epsilon_generate(obj)
	VALUE obj;
{
	Epsilon *image = NULL;
	Data_Get_Struct(obj, Epsilon, image);
	if(epsilon_exists(image) == EPSILON_OK) {
		return Qfalse;
	} else {
		if(epsilon_generate(image) != EPSILON_OK) {
			rb_raise(rb_eStandardError, "Generating thumbnail failed");
		}
		return obj;
	}
}

VALUE rb_epsilon_filename(obj)
	VALUE obj;
{
	Epsilon *image = NULL;
	Data_Get_Struct(obj, Epsilon, image);
	return rb_str_new2(epsilon_file_get(image));
}

VALUE rb_epsilon_thumbnail(obj)
	VALUE obj;
{
	Epsilon *image = NULL;
	rb_epsilon_generate(obj);
	Data_Get_Struct(obj, Epsilon, image);
	return rb_str_new2(epsilon_thumb_file_get(image));
}

void Init_epsilon () {
	epsilon_init();
	cEpsilon = rb_define_class("Epsilon", rb_cObject);
	rb_define_singleton_method(cEpsilon, "new", rb_epsilon_new, 1);
	rb_define_method(cEpsilon, "generate", rb_epsilon_generate, 0);
	rb_define_method(cEpsilon, "thumbnail", rb_epsilon_thumbnail, 0);
	rb_define_method(cEpsilon, "filename", rb_epsilon_filename, 0);
}
